/*****************************************************************************

                  饹ȥåˡץѥġ
                     ----- ǡץ -----

         copyright (c) 1993  by T.Mori <mori@forest.dnj.ynu.ac.jp>
	 All right reserved.

	 $Author: mori $
	 $Revision: 1.3 $
	 $Date: 1993/10/30 09:57:26 $


	 

0.Ϥ

  ΥץϿä§(͹硦ŻҾ󹩳ز)͹ΩŻҾ
  󹩳̼¸Τȼ˳ȯΤǤ
  ޤ󤬡GNU GENERAL PUBLIC LICENSE ŬѤΤ
  ΥץΤʤʬѹήѤ⼫ͳȤޤ
  Хʤɤޤ顤嵭ɥ쥹ޤϢĺйǤ

1.󥹥ȡˡ

  ̤Cѥǥѥ뤷ƲANSI C ǤϤʤ
  K&R(1)Υѥ餬ɬפǤ㤨мΤ褦ˤޤ

  cc -O -o pbmtoild pbmtoild.c

2.Ȥ

  ΥץϰΥե⤷ɸϤpbm(ƥȷ
  ǤP1)Υӥåȥޥåפɤ߹ߡɸϤˤΥǡ򥤥
  ȥåˡץबǤǡѴΤ
  Фޤäơ

  xbmtopbm xbmfile | pbmtoild | il

  ʤɤȤ il ȤȤ˵ư뤳Ȥ¿Ȼפޤ


3.

  ΥץѤpbmե򥤥饹ȥåѴ
  뤳ȤǤޤ̤ˡ̤Υӥåȥޥåפϰ
  ޤʤȤ¿ΤդƲդ˲뤿
  ˤϥӥåȥޥåפκʳǹפ򤹤ɬפޤ

  줫顤äĤŻʤΤǥץबǤ ()

*****************************************************************************/

#include <stdio.h>
#ifndef TRUE
#define TRUE	(1)
#define FALSE	(0)
#endif
#define PBM_MAGIC1	'P'
#define PBM_MAGIC2	'1'


char
pbm_getc( file )
FILE *file;
{
  int ich;
  char ch;
  
  ich = getc( file );
  if ( ich == NULL ) {
    return (-1); /* invalid */
  }
  ch = (char) ich;
  
  if ( ch == '#' ){
    do {
      ich = getc( file );
      if ( ich == NULL ) {
	return (-1); /* invalid */
      }
      ch = (char) ich;
    } while ( ch != '\n' );
  }
  
  return ( ch );
}


pbm_getint( file )
     FILE *file;
{
  char ch;
  int i;
  
  do {
    if ((ch = pbm_getc( file )) < 0) {
      return (-1); /* invalid */
    }
  } while ( ch == ' ' || ch == '\t' || ch == '\n' );
  
  if ( ch < '0' || ch > '9' ) {
    return (-1); /* invalid */
  }
  
  i = 0;
  do {
    i = i * 10 + ch - '0';
    if ((ch = pbm_getc( file )) < 0) {
      return (-1); /* invalid */
    }
  } while ( ch >= '0' && ch <= '9' );
  
  return ( i );
}


pbm_getbit( file )
     FILE *file;
{
  char ch;
  
  do {
    if ((ch = pbm_getc( file )) < 0) {
      return (-1); /* invalid */
    }
  } while ( ch == ' ' || ch == '\t' || ch == '\n' );
  
  if ( ch != '0' && ch != '1' ) {
    return (-1); /* invalid */
  }
  
  return ( ch );
}



IsPBMfile(fp, widthptr, heightptr, datap)
     FILE *fp;
     int *widthptr, *heightptr;
     char **datap;
{
  int ch1, ch2, i, j;

  if ((ch1 = getc( fp )) == EOF) {
    fclose(fp);
    return FALSE;
  }
  if ((ch2 = getc( fp )) == EOF) {
    fclose(fp);
    return FALSE;
  }
  if (ch1 != PBM_MAGIC1 || ch2 != PBM_MAGIC2) {
    fclose(fp);
    return FALSE;
  }
  if ((*widthptr = pbm_getint( fp )) < 0 ) {
    fclose(fp);
    return FALSE;
  }
  if ((*heightptr = pbm_getint( fp )) < 0 ) {
    fclose(fp);
    return FALSE;
  }
  
  *datap = (char *)malloc( *widthptr * (*heightptr) );
  if (*datap == NULL) {
    fclose(fp);
    return FALSE;
  }

  for ( i = 0; i < *heightptr; i++ ) {
    for ( j = 0; j < *widthptr ; j++ ) {
      if (((*datap)[ *widthptr*i + j] = pbm_getbit(fp)) < 0) {
	fclose(fp);
	return FALSE;
      }
    }
  }
  fclose( fp );
  return TRUE;
}


main(argc,argv)
	int argc;
	char *argv[];
{
  int width, height;
  char *data;
  int i,j,comma,printrun,r;
  FILE *datafpt;

  switch(argc){
  case 1:
    datafpt = stdin;
    break;
  case 2:
    if ((datafpt = fopen(argv[1],"r")) == (FILE *)NULL) {
      usage(argv[0]);
      exit(1);
    };
    break;
  default:
    usage(argv[0]);
    exit(1);
  }
  
  if (! IsPBMfile(datafpt, &width, &height, &data) ) {
    fprintf(stderr, "%s : invalid input file.\n", argv[0]);
    exit(1);
  }

  printf("data(tmp,\n");
  printf("[\n");

  for( i=0; i<width; i++ ) {
    printf("[");
    comma = FALSE;
    printrun = FALSE;
    for( j=0; j<height;) {
      if (data[width*j+i]=='0') {
	j++;
	continue;
      }
      for (r=0; (j<height)&&data[width*j+i] == '1'; r++,j++);
      if (! comma) {
	comma = TRUE;
      } else {
	printf(",");
      }
      printf("%d",r);
      printrun = TRUE;
    }
    if (! printrun) {
      printf("0");
    }
    printf("]");
    if (i+1 == width) {
      printf("\n");
    } else {
      printf(",\n");
    }
  }

  printf("],\n[\n");

  for( i=0; i<height; i++ ) {
    printf("[");
    comma = FALSE;
    printrun = FALSE;
    for( j=0; j<width;) {
      if (data[width*i + j]=='0') {
	j++;
	continue;
      }
      for (r=0; (j<width)&&data[width*i+j] == '1'; r++,j++);
      if (! comma) {
	comma = TRUE;
      } else {
	printf(",");
      }
      printf("%d",r);
      printrun = TRUE;
    }
    if (! printrun) {
      printf("0");
    }
    printf("]");
    if (i+1 == height) {
      printf("\n");
    } else {
      printf(",\n");
    }
  }

  printf("]).\n");

}


usage(progname)
     char *progname;
{
  fprintf(stderr, "Usage: %s [filename]\n", progname);
}
